/*
Copyright (C) 2000,2001 Stefan Duffner 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef EXPORTVHDL_H
#define EXPORTVHDL_H

#include "Export.h"

class Options;

/**
 * @class ExportVHDL
 * @brief Class that manages export to VHDL.
 *
 */

class ExportVHDL : public Export
{
  public:
    ExportVHDL(Options* opt);

    void doExport();
    QString fileFilter();

  private:
    /// Name of the machine to export
    QString mname;
    /// If TRUE, the fixed encoding for the states is used, otherwise an enum type.
    bool state_encoding;
    /// If TRUE, the reset signal will be handled synchronously, otherwise asynchronously.
    bool synchronous_reset;
    /// If TRUE, 'std_logic' is used instead of 'bit'
    bool use_std_logic;

    void writeEnvironment();
    void writeEntity();
    void writeArchitecture();
    void writeClockProcess();
    void writeStateProcess();
};

#endif
