/*
Copyright (C) Stefan Duffner 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef EXPORTVHDLDLGIMPL_H
#define EXPORTVHDLDLGIMPL_H
#include "ExportVHDLDlg.h"

class Options;

class ExportVHDLDlgImpl : public ExportVHDLDlg
{
    Q_OBJECT

public:
    ExportVHDLDlgImpl( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~ExportVHDLDlgImpl();

    /// Returns the 'symbolic states' flag 
    bool getSymbolicStates() { return symbolic_states; };
    /// Sets the 'symbolic states' flag 
    void setSymbolicStates(bool ss) { symbolic_states = ss; };
    /// Returns the 'synchronous reset' flag 
    bool getSyncReset() { return sync_reset; };
    /// Sets the 'synchronous reset' flag 
    void setSyncReset(bool sr) { sync_reset = sr; };
    /// Returns the 'std_logic package' flag 
    bool getStdLogic() { return stdlogic; };
    /// Sets the 'std_logic package' flag 
    void setStdLogic(bool sl) { stdlogic = sl; };

    void init(Options* opt);

public slots:
    void symbolicNamesClicked();
    void synchronousResetClicked();
    void useStdLogicClicked();

private:
    /// If TRUE use symbolic names for states
    bool symbolic_states;
    /// If TRUE use synchronous reset, otherwise asynchronous reset
    bool sync_reset;
    /// if TRUE use std_logic_1164 package
    bool stdlogic;
};

#endif // EXPORTVHDLDLGIMPL_H
