/*
Copyright (C) 2000,2001 Stefan Duffner 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef LISTBOXITEMS_H
#define LISTBOXITEMS_H

class QListbox;

/**
 * @class LBArrowLine
 * @brief Listbox item for the machine properties dialog.
 *
 * Listbox item which paints the unfilled arrowhead for a transition.
 */
class LBArrowLine : public QListBoxItem
{
  public:
    LBArrowLine(QListBox*);

    int height(const QListBox*) const;
    int width(const QListBox*) const;
    void paint(QPainter*);

  private:
    /// Height of the item
    int h;
    /// Width of the item
    int w;
};

/**
 * @class LBArrowFilled
 * ListBox item for the machine properties dialog.
 * Listbox item which paints the filled arrowhead for a transition.
 */
class LBArrowFilled : public QListBoxItem
{
  public:
    LBArrowFilled(QListBox*);

    int height(const QListBox*) const;
    int width(const QListBox*) const;
    void paint(QPainter*);

  private:
    /// Height of the item
    int h;
    /// Width of the item
    int w;
};


/**
 * @class LBArrowWhite
 * ListBox item for the machine properties dialog.
 * Listbox item which paints the white arrowhead for a transition.
 */
class LBArrowWhite : public QListBoxItem
{
  public:
    LBArrowWhite(QListBox*);

    int height(const QListBox*) const;
    int width(const QListBox*) const;
    void paint(QPainter*);

  private:
    /// Height of the item
    int h;
    /// Width of the item
    int w;
};


/**
 * @class LBArrowFilledPointed
 * ListBox item for the machine properties dialog.
 * Listbox item which paints the filled pointed arrowhead for a transition.
 */
class LBArrowFilledPointed : public QListBoxItem
{
  public:
    LBArrowFilledPointed(QListBox*);

    int height(const QListBox*) const;
    int width(const QListBox*) const;
    void paint(QPainter*);

  private:
    /// Height of the item
    int h;
    /// Width of the item
    int w;
};

/**
 * @class LBArrowWhitePointed
 * ListBox item for the machine properties dialog.
 * Listbox item which paints the white pointed arrowhead for a transition.
 */
class LBArrowWhitePointed : public QListBoxItem
{
  public:
    LBArrowWhitePointed(QListBox*);

    int height(const QListBox*) const;
    int width(const QListBox*) const;
    void paint(QPainter*);

  private:
    /// Height of the item
    int h;
    /// Width of the item
    int w;
};


#endif
